/*
 * skin effect samples programs
 * 2016-10 Kouichi Hirabayashi
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <complex.h>
#include "Complex.h"

int C();
int C1();

int main(argc, argv) char **argv;
{
// Please rmove the comment of the required program.
  C();		// equivalent resistance of thin tube and infinitesimal wire
//  C1();	// current distribution of thin tube and infinitesimal wire
  exit(0);
}

// equivalent resistance of thin tube and infinitesimal wire 

int C()
{
  int i, n;
  double a, b[4], t, f, u, g, m, m2, rdc, r[4], x, delta, PI;

  PI = atan2(0.0, -1.0);
  a = 5e-3;             // radius of screen
  t = 1e-4;		// thickness
  b[0] = a * 0.05;	// distance 1
  b[1] = a * 0.10;	// distance 2
  b[2] = a * 0.20;	// distance 3
  b[3] = a * 0.50;	// sidtance 4
  u = 4e-7 * PI;        // permeability
  g = 5.80e7;           // conductivity
  rdc = 1.0 / (g * PI * (a * a - (a - t) * (a - t)));
  for (f = 1e0; f <= 1e9; f *= 1.02) {	// frequency
	m = 2.0 * PI * f * u * g * a * t;
	delta = sqrt(2.0 / (2.0 * PI * f * u * g));	// skin depth
	m2 = m * m;
	for (i = 0; i < 4; i++) {
		r[i] = 0.0;
		for (n = 1; n < 100; n++) {
			x = pow(b[i] / a, (double)(2 * n)) * m2 / (m2 + (double)(n * n));
			r[i] += x;
			if (x / r[i] < 1e-3)
				break;
		}
		if (100 <= n) fprintf(stderr, "n(%d)\n", n);
	}
	// x-axis = frequency (Fig. 1)
	printf("%g %g %g %g %g\n", f, r[0], r[1], r[2], r[3]);
	// x-axis = t / skin-depth (Fig. 2)
//	printf("%g %g %g %g %gn", t / delta, r[0], r[1], r[2], r[3]);
  }
  return 0;
}

// current distribution of thin tube and infinitesimal wire 

int C1()
{
  double a, s, t, f, u, g, m, n, p, rdc, PI;
  COMPLEX z, z0, z1, z2, z3;

  PI = atan2(0.0, -1.0);
  a = 5e-3;             // radius of screen
  t = 1e-4;		// thickness
  s = a * 0.10;		// distance
  u = 4e-7 * PI;        // permeability
  g = 5.80e7;           // conductivity
  rdc = 1.0 / (g * PI * (a * a - (a - t) * (a - t)));
  f = 1e6;	// frequency
  z3 = (COMPLEX)0.0;
  for (p = 0.0; p <= 2.0 * PI; p += PI / 180.0) {	// angle
	z0 = z1 = (COMPLEX)0.0;
	for (n = 1; n < 50; n++) {
		m = 2.0 * PI * f * u * g * a * t;
		z2 = pow(s / a, (double)n) * I * m / (n + I * m);
		z0 += z2;	// i0
		z1 += z2 * cos((double)n * p);	// i0(p)
		if (cabs(z2 / z0) < 1e-3)
			break;
	}
	z0 *= -I / (PI * a * t);	// maximam current dencity
	z1 *= -I / (PI * a * t);	// current dencity at p
	z3 += z1;	// integral (sumr) of z1
	z = z1 / z0;
	printf("%g %g %g\n", p, cabs(z), carg(z));
//	printf("%g %g %g %g\n", p, cabs(z), carg(z), cabs(z3));
  }
  return 0;
}
